#include "cmdLineParser.h"

int Parser::isOption(const char *arg){
	if(arg == NULL || strlen(arg) < 2 )
		return 0;

   	if(arg[0] == '-' && !isdigit(arg[1]))
      	return 1;
   	return 0;
}

void Parser::replaceString(string& subject, const string& search, const string& replace){
    size_t pos = 0;
    while ((pos = subject.find(search, pos)) != std::string::npos) {
         subject.replace(pos, search.length(), replace);
         pos += replace.length();
    }
}

void Parser::cmdLineHelp(){

	cerr << "sstsum_timer options: \n" ;
    cerr << "<structure alignment>" 
         << "    " << "Input file containing alignment in secondary strutcure states (Format: FASTA) \n" 
         << "    " << "Default: data/testdata/d1hhoa__vs_d1hbra_-sse.afasta" << endl << endl
         << "<SST input file 1> <SST input file 2> <structure alignment>"
         << "    " << "<SST input file 1>   : Output file from SST (secondary structure assignment program) for the 1st PDB \n"
         << "    " << "<SST input file 2>   : Output file from SST (secondary structure assignment program) for the 2nd PDB \n"
         << "    " << "<structure alignment>: A structure alignment between 1st and 2nd PDBs\n" 
         << "    " << "Default: data/testdata/d1hhoa_.ent_sst data/testdata/d1hbra_.ent_sst data/testdata/d1hhoa__vs_d1hbra_.afasta" << endl << endl;  
    
}

Parser::Parser(){}

Parser::Parser(int argc, char **argv){
    bool isOptn = true;
    char ** optn;
    
    if(argc == 2 && !strcmp(argv[1],"--help")){
        cmdLineHelp();
        exit(0); 
    } 

    if(argc == 1){
        return;
    } else if(argc == 2){    
        fflag = true;
        stralignf = argv[1];
    } else if(argc == 4){
        fflag = false;
        sstf1 = argv[1];
        sstf2 = argv[2];
        sstalignf = argv[3];
    } else {
        cerr << "SSTTime: Unable to associate the arguments with any valid options!\n";
        cerr << "Try \'SSTTime --help\' for more information.\n";
        exit(0); 
    }

}


