#ifndef NULLMODEL_H
#define NULLMODEL_H
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <cmath>
#include <string>
#include <stdint.h>
#include <map>
#include <vector>
#include <sstream>
#include <bits/stdc++.h>
#include "aaAlphabet.h"
using namespace std ;

class NullModel {
    private:
        AAAlphabet alphabet; // this will  be inferred from the input file
        vector<vector<double>> ctx2pr;
        size_t order;
        void sanityCheckProbs();
        void allPermutations(string&, int, string&, vector<string>&);
    public:
        NullModel();
        NullModel(string);
        void normalize(vector<double>&);
        double pr(string);
        size_t getOrder();
        string getAlphabet();
        int getAlphabetSize();
        bool isCompatible(string);
};
#endif
