#ifndef DPCLASS_H
#define DPCLASS_H
#include<iostream>
#include<fstream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cassert>
#include<string>
#include<stdint.h>
#include<limits>
#include<map>
#include<vector>
#include<sstream>
#include<time.h>
#include <algorithm>

#include "misc.h"
#include "SubmatClass.h"
#include "nullModel.h"
#include "dpcellClass.h"
using namespace std;

class threeStateDPAClass_t {
  private:
    string S;
    string T;
    NullModel nullMdl;
    SubmatClass_t submat;
    int inferredSubmat_N;  
    map<string,double> fsaPr;
   
    double paramStatementMsglen;
    double algnModelMsgLen;
    string optAlgnFSAStr;
    bool matchOnly = false;
    
    void initParams();
    void estimateParams(string);
    double evalNegLogMatches(vector<string>, int); 
    double evalNegLogMatches_fullAlignment(string, vector<string>, int); 
    double evalNegLogMatchesOnly_fullAlignment(string, vector<string>, int); 
    void estimateSubmatParam(string);
    void estimate3StateMachineParams_dirichlet(int); //est as the mode under the assoc. dirichlet
    bool runstat;
  public:
    threeStateDPAClass_t(string &,string &, string &, NullModel &,SubmatClass_t &); // overloaded to compute ivalue 
   
    double getOptAlignMsgLen();
    string getOptAlignFSAstr();
    double fsa2IA(string);
    double fsa2ISTgA(string);
    double fsa2ISTgAMatchOnly(string);
    int getInferredSubmatN();
   
};
#endif
